import socket
import select
import signal
import datetime
import time
import serial
import lectura



def read_single_keypress():
    """Waits for a single keypress on stdin.

    This is a silly function to call if you need to do it a lot because it has
    to store stdin's current setup, setup stdin for reading single keystrokes
    then read the single keystroke then revert stdin back after reading the
    keystroke.

    Returns the character of the key that was pressed (zero on
    KeyboardInterrupt which can happen when a signal gets handled)

    """
    import termios, fcntl, sys, os
    signal.signal(signal.SIGINT, handler)
    fd = sys.stdin.fileno()
    # save old state
    flags_save = fcntl.fcntl(fd, fcntl.F_GETFL)
    attrs_save = termios.tcgetattr(fd)
    # make raw - the way to do this comes from the termios(3) man page.
    attrs = list(attrs_save) # copy the stored version to update
    # iflag
    attrs[0] &= ~(termios.IGNBRK | termios.BRKINT | termios.PARMRK 
                  | termios.ISTRIP | termios.INLCR | termios. IGNCR 
                  | termios.ICRNL | termios.IXON )
    # oflag
    attrs[1] &= ~termios.OPOST
    # cflag
    attrs[2] &= ~(termios.CSIZE | termios. PARENB)
    attrs[2] |= termios.CS8
    # lflag
    attrs[3] &= ~(termios.ECHONL | termios.ECHO | termios.ICANON
                  | termios.ISIG | termios.IEXTEN)
    termios.tcsetattr(fd, termios.TCSANOW, attrs)
    # turn off non-blocking
    fcntl.fcntl(fd, fcntl.F_SETFL, flags_save & ~os.O_NONBLOCK)
    # read a single keystroke
    try:
        ret = sys.stdin.read(1) # returns a single character
    except KeyboardInterrupt: 
        ret = 0
    finally:
        # restore old state
        termios.tcsetattr(fd, termios.TCSAFLUSH, attrs_save)
        fcntl.fcntl(fd, fcntl.F_SETFL, flags_save)
    return ret



def handler( signum, frame):
	print 'error'	

# esta funcion sirve para que cuando detecta el cierre del programa forzado efectue la funcion handler, que sera nuestro tratamiento de error
signal.signal(signal.SIGINT, handler)
print 'Iniciando el programa'
socketlisten = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
# creamos el socket-lectura
#socketlisten.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
# cambiamos las opciones para que el socket sea liberado cada vez k se usa
socketlisten.bind(('0.0.0.0',9999))
# creamos socket-escritura
socketwrite = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
# creamos el socket servidor
#socketwrite.setsockopt(socket.SOL_SOCKET, socket.SO_REUSEADDR, 1)
# cambiamos las opciones para que el socket sea liberado cada vez k se usa
socketwrite.bind(('0.0.0.0',0))
print 'Creamos y damos direccion al objetos lectura/escritura'
# 5 escuchas
# Creamos un conjunto
print 'Introducimos el objeto socket-lectura'
Lista = list()
print 'Introducimos el objeto socket-escritura'
Lista.append(socketlisten)
print 'Entramos en el bucle de select'
print 'Mando para el Coche'
print '    w(front)'
print 'a(<-)	(->)d'
print '    x/s (back)'
while 1:
	cadena = ''
	a = read_single_keypress()
	if(a == 'a'):
		cadena = 'GET /mov-protocol/left HTTP/1.1'
		print 'Direccion: Izquierda'
	elif(a == 'd'):
		cadena = 'GET /mov-protocol/right HTTP/1.1'
		print 'Direccion: Derecha'
	elif(a == 'x' or a == 's'):
		cadena = 'GET /mov-protocol/back HTTP/1.1'
		print 'Direccion: Atras'
	elif(a == 'w'):
		cadena = 'GET /mov-protocol/front HTTP/1.1'
		print 'Direccion: Adelante'
	elif(a == 'q'):
		print 'salimos'
		break
	elif(a == 'e'):
		cadena = 'GET /mov-protocol/stop HTTP/1.1'
		print 'Direccion: Parada'
	else:
		print 'la letra ' +a+ ' no es una direccion para el coche'
		print '	w(front)'
		print 'a(<-)	(->)d'
		print ' x/s (back)'
		continue
	socketwrite.sendto(cadena, ('192.168.0.109',9999))
